<?php
include('./config.php');

$ErrorMessage['1']='System error';
$ErrorMessage['2']='Forbidden';
$ErrorMessage['3']='Required element not found';
$ErrorMessage['999']='Unknown method';

$post=file_get_contents('php://input');
preg_match('/<methodCall>(.*)<\/methodCall>/s',$post,$m);
$call=$m[1];
preg_match('/<methodName>\s*(\S+)\s*<\/methodName>/s',$call,$m);
$name=$m[1];

if($name==='metaWeblog.newPost'){
	EntryPost($call);
}else{
	PrintError('999');
}
function PrintError($n){
	$error="{$GLOBALS['ErrorMessage'][$n]}";
	echo <<<EOF
<?xml version="1.0"?>
<methodResponse>
<fault><value><struct>
<member><name>faultCode</name><value><int>{$n}</int></value></member>
<member><name>faultString</name><value><string>{$error}</string></value></member>
</struct></value></fault>
</methodResponse>
EOF;
	exit();
}
function EntryPost($call){
	preg_match_all('/<param>\s*<value>\s*<\w+>\s*(.*?)\s*<\/\w+>\s*<\/value>\s*<\/param>/s',$call,$m,PREG_SET_ORDER);
	for($i=0;$i<count($m);$i++){
		$param[]=$m[$i][1];
	}
	$user=$param[1];
	$pass=$param[2];
	if($GLOBALS['FtpUser']!==$user || $GLOBALS['FtpPass']!==$pass) PrintError('2');
	preg_match_all('/<member>\s*<name>\s*(\w+)\s*<\/name>\s*<value>\s*<string>\s*(.*?)\s*<\/string>\s*<\/value>\s*<\/member>/s',$param[3],$m,PREG_SET_ORDER);
	for($i=0;$i<count($m);$i++){
		$m[$i][2]=htmlspecialchars_decode($m[$i][2],ENT_QUOTES);
		if($m[$i][1]==='title'){
			$replace['title']=htmlspecialchars($m[$i][2],ENT_QUOTES);
		}elseif($m[$i][1]==='description'){
			$replace['body']=$m[$i][2];
		}elseif($m[$i][1]==='mt_text_more'){
			$replace['more']=$m[$i][2];
		}
	}

	if(!$replace['title']) PrintError('3');
	if(!$replace['body']) PrintError('3');
	$now=localtime();
	$now[5]+=1900;
	$now[4]++;
	for($i=0;$i<5;$i++){
		if(strlen($now[$i])==1) $now[$i]="0$now[$i]";
	}
	$replace['Y']=$now[5];
	$replace['M']=$now[4];
	$replace['D']=$now[3];
	$replace['h']=$now[2];
	$replace['m']=$now[1];
	$replace['s']=$now[0];
	$replace['e']="$now[5]$now[4]$now[3]$now[2]$now[1]$now[0]";
	$replace['body']=preg_replace('/<!--END-->/','',$replace['body']);
	$replace['more']=preg_replace('/<!--END-->/','',$replace['more']);
	$replace['body']=preg_replace('/<!--BEGIN[^\-]*-->/','',$replace['body']);
	$replace['more']=preg_replace('/<!--BEGIN[^\-]*-->/','',$replace['more']);
	$replace['body']=preg_replace('/<!--#+/','<!--',$replace['body']);
	$replace['more']=preg_replace('/<!--#+/','<!--',$replace['more']);
	$entry=file_get_contents("template_entry.txt");
	$entry=preg_replace('/[\r\n]/','',$entry);
	$entry=preg_replace('/&\$(\w+);/e',"\$replace['$1']",$entry);
	$ftp=ftp_connect($GLOBALS['FtpServer'],$GLOBALS['FtpPort']) or PrintError('1');
	ftp_login($ftp,$GLOBALS['FtpUser'],$GLOBALS['FtpPass']) or 	PrintError('1');
	if($GLOBALS['FtpPasv']) ftp_pasv($ftp,true);
	ftp_chdir($ftp,$GLOBALS['FtpRoot']);
	$size=ftp_size($ftp,"entry/$now[5]$now[4].shtml");
	if($size>0){
		$fh=tmpfile();
		ftp_fget($ftp,$fh,"entry/$now[5]$now[4].shtml",FTP_BINARY);
		$tell=ftell($fh);
		fseek($fh,0);
		$file=fread($fh,$tell);
		fclose($fh);
		if($size!=$tell) PrintError('1');
	}
	$file="<!--BEGIN {$replace['e']}-->{$entry}<!--END-->\n{$file}";
	$fh=tmpfile();
	fwrite($fh,$file);
	fseek($fh,0);
	ftp_fput($ftp,"entry/$now[5]$now[4].shtml",$fh,FTP_BINARY);
	fclose($fh);
	$list=array();
	$list[]="<!--BEGIN {$replace['e']}-->{$entry}<!--END-->";
	$size=ftp_size($ftp,"top.shtml");
	if($size>0){
		$fh=tmpfile();
		ftp_fget($ftp,$fh,"top.shtml",FTP_BINARY);
		$tell=ftell($fh);
		fseek($fh,0);
		$file=fread($fh,$tell);
		fclose($fh);
		preg_match_all('/(<!--BEGIN \d+-->.*?<!--END-->)/s',$file,$m,PREG_SET_ORDER);
		for($i=0;$i<count($m)&&$i<$GLOBALS['LimitTop']-1;$i++){
			$list[]=$m[$i][1];
		}
	}
	$file=join("\n",$list);
	$fh=tmpfile();
	fwrite($fh,$file);
	fseek($fh,0);
	ftp_fput($ftp,"top.shtml",$fh,FTP_BINARY);
	fclose($fh);
	$list=array();
	$size=ftp_size($ftp,"recent.shtml");
	if($size>0){
		$fh=tmpfile();
		ftp_fget($ftp,$fh,"recent.shtml",FTP_BINARY);
		$tell=ftell($fh);
		fseek($fh,0);
		$file=fread($fh,$tell);
		fclose($fh);
		preg_match_all('/(<!--BEGIN-->.*?<!--END-->)/s',$file,$m,PREG_SET_ORDER);
		for($i=0;$i<count($m)&&$i<$GLOBALS['LimitRecent']-1;$i++){
			$list[]=$m[$i][1];
		}
	}
	$file=file_get_contents("template_recent.txt");
	preg_match('/(<!--BEGIN-->.*<!--END-->)/s',$file,$m);
	$item=preg_replace('/&\$(\w+);/e',"\$replace['$1']",$m[1]);
	array_unshift($list,$item);
	$file=preg_replace('/<!--BEGIN-->.*<!--END-->/s',join("\n",$list),$file);
	$fh=tmpfile();
	fwrite($fh,$file);
	fseek($fh,0);
	ftp_fput($ftp,"recent.shtml",$fh,FTP_BINARY);
	fclose($fh);
	$file=file_get_contents("template_monthly.txt");
	preg_match('/<!--BEGIN-->(.*)<!--END-->/s',$file,$m);
	$item=$m[1];
	$list=ftp_nlist($ftp,'entry');
	rsort($list);
	$plugin='';
	foreach($list as $name){
		if(preg_match('/(\d{4})(\d{2})\.shtml/',$name,$m)){
			$year=$m[1];
			$month=$m[2];
			$line=$item;
			$line=preg_replace('/&\$Y;/',$year,$line);
			$line=preg_replace('/&\$M;/',$month,$line);
			$plugin.=$line."\n";
		}
	}
	$file=preg_replace('/<!--BEGIN-->.*<!--END-->/s',$plugin,$file);
	$fh=tmpfile();
	fwrite($fh,$file);
	fseek($fh,0);
	ftp_fput($ftp,"monthly.shtml",$fh,FTP_BINARY);
	fclose($fh);
	ftp_close($ftp);
	echo <<<EOF
<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params>
<param><value><string>1</string></value></param>
</params></methodResponse>
EOF;
}
?>

